//For scooping the good shit
//Particle
datablock ParticleData(PooScoopParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin 		= 0;
   spinRandomMax 		= 180;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 200;
   textureName          = "base/data/particles/star1";
   colors[0]    		= "0.7 0.7 0.8 0.8";
   colors[1]     		= "1.0 1.0 1.0 0.2";
   sizes[0]     		= 0.42;
   sizes[1]     		= 0.24;
};
//Emitter
datablock ParticleEmitterData(PooScoopEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 4;
   ejectionVelocity = 8;
   velocityVariance = 1;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 180;
   overrideAdvance  = false;
   particles 		= "PooScoopParticle";
   uiName 			= "Clean Stars";
};
//Explosion
datablock ExplosionData(PooScoopExplosion)
{
   lifeTimeMS = 400;
   soundProfile = ScoopHitSound;
   particleEmitter = PooScoopEmitter;
   particleDensity = 8;
   particleRadius = 0.2;
   faceViewer     = true;
   shakeCamera = false;
   explosionScale = "1 1 1";
   lightStartRadius = 2;
   lightEndRadius = 0;
   lightStartColor = "0.2 0.4 0.8";
   lightEndColor = "0 0 0";
};
//Projectile
datablock ProjectileData(PooScoopProjectile)
{
   directDamage        = 0;
   directDamageType    = 0;
   radiusDamageType    = 0;
   explosion           = PooScoopExplosion;
   muzzleVelocity      = 50;
   velInheritFactor    = 1;
   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   hasLight    		   = false;
   gravityMod 		   = 0.0;
   lightRadius 		   = 3.0;
   lightColor 		   = "0 0 0.5";
   uiName			   = "Poo Scoop";
};
//Item
datablock ItemData(PooScoopItem)
{
	category = "Weapon";
	className = "Weapon";
	uiName = "Poop Scoop";
	shapeFile = "Add-ons/Player_Kitty/MESH/PooScoop.dts";
	iconName = "Add-ons/Player_Kitty/IMG/Icon_PooScoop";
	emap = true;
	canDrop = true;
	doColorShift = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	image = PooScoopImage;
};
//Image
datablock ShapeBaseImageData(PooScoopImage)
{
	shapeFile = "Add-ons/Player_Kitty/MESH/PooScoop.dts";
	emap = true;
	correctMuzzleVector = false;
	melee = true;
	doRetraction = false;
	armReady = true;
	doColorShift = false;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = "0.7 1.2 -0.25";
	className = "WeaponImage";
	item = PooScoopItem;
	ammo = "";
	projectile = PooScoopProjectile;
	projectileType = Projectile;

    //Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.4;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = WeaponDrawSound;
	stateSequence[0]                 = "s_hold";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]					 = "PreFire";
	stateScript[2]                   = "onPreFire";
	stateAllowImageChange[2]         = false;
	stateTimeoutValue[2]             = 0.2;
	stateTransitionOnTimeout[2]      = "Fire";

	stateName[3]                     = "Fire";
	stateTransitionOnTimeout[3]      = "CheckFire";
	stateTimeoutValue[3]             = 0.2;
	stateFire[3]                     = true;
	stateAllowImageChange[3]         = false;
	stateSequence[3]                 = "s_scoop";
	stateScript[3]                   = "onFire";
	stateWaitForTimeout[3]			 = true;

	stateName[4]					 = "CheckFire";
	stateTransitionOnTriggerUp[4]	 = "StopFire";
	stateTransitionOnTriggerDown[4]	 = "Fire";

	stateName[5]                     = "StopFire";
	stateTransitionOnTimeout[5]      = "Ready";
	stateTimeoutValue[5]             = 1.0;
	stateAllowImageChange[5]         = false;
	stateWaitForTimeout[5]			 = true;
	stateSequence[5]                 = "s_stop";
	stateScript[5]                   = "onStopFire";
};
function PooScoopImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}
function PooScoopImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
function PooScoopProjectile::OnCollision(%this, %obj, %col, %fade, %pos, %normal, %client)
{
	if(!%col.isCCW)
	{
		return;
	}
	else
	{
		%data = %col.getDatablock();
		if(%data.uiName $= "Litter-box" && %data.isOpen)
		{
			%col.doorClose(%client);
		}
	}
	return Parent::OnCollision(%this, %obj, %col, %fade, %pos, %normal, %client);
}